var _inherits = require('babel-runtime/helpers/inherits').default;

var _classCallCheck = require('babel-runtime/helpers/class-call-check').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard').default;

exports.__esModule = true;
/* eslint hammerhead/proto-methods: 0 */

var _baseDomAdapter = require('./base-dom-adapter');

var _baseDomAdapter2 = _interopRequireDefault(_baseDomAdapter);

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

var _utilsUrl = require('../../utils/url');

var urlUtils = _interopRequireWildcard(_utilsUrl);

var _utilsParse5 = require('../../utils/parse5');

var parse5Utils = _interopRequireWildcard(_utilsParse5);

var Parse5DomAdapter = (function (_BaseDomAdapter) {
    _inherits(Parse5DomAdapter, _BaseDomAdapter);

    function Parse5DomAdapter(isIframe, crossDomainPort) {
        _classCallCheck(this, Parse5DomAdapter);

        _BaseDomAdapter.call(this);

        this.isIframe = isIframe;
        this.crossDomainPort = crossDomainPort;
    }

    Parse5DomAdapter.prototype.removeAttr = function removeAttr(el, attr) {
        for (var i = 0; i < el.attrs.length; i++) {
            if (el.attrs[i].name === attr) {
                el.attrs.splice(i, 1);

                return;
            }
        }
    };

    Parse5DomAdapter.prototype.getAttr = function getAttr(el, attr) {
        for (var i = 0; i < el.attrs.length; i++) {
            if (el.attrs[i].name === attr) return el.attrs[i].value;
        }

        return null;
    };

    Parse5DomAdapter.prototype.getClassName = function getClassName(el) {
        return this.getAttr(el, 'class') || '';
    };

    Parse5DomAdapter.prototype.hasAttr = function hasAttr(el, attr) {
        return this.getAttr(el, attr) !== null;
    };

    Parse5DomAdapter.prototype.hasEventHandler = function hasEventHandler(el) {
        for (var i = 0; i < el.attrs.length; i++) {
            if (this.EVENTS.indexOf(el.attrs[i].name)) return true;
        }

        return false;
    };

    Parse5DomAdapter.prototype.getTagName = function getTagName(el) {
        return el.tagName || '';
    };

    Parse5DomAdapter.prototype.setAttr = function setAttr(el, attr, value) {
        for (var i = 0; i < el.attrs.length; i++) {
            if (el.attrs[i].name === attr) {
                el.attrs[i].value = value;

                return value;
            }
        }

        el.attrs.push({ name: attr, value: value });

        return value;
    };

    Parse5DomAdapter.prototype.setScriptContent = function setScriptContent(script, content) {
        script.childNodes = [parse5Utils.createTextNode(content, script)];
    };

    Parse5DomAdapter.prototype.getScriptContent = function getScriptContent(script) {
        return script.childNodes.length ? script.childNodes[0].value : '';
    };

    Parse5DomAdapter.prototype.getStyleContent = function getStyleContent(style) {
        return style.childNodes.length ? style.childNodes[0].value : '';
    };

    Parse5DomAdapter.prototype.setStyleContent = function setStyleContent(style, content) {
        style.childNodes = [parse5Utils.createTextNode(content, style)];
    };

    Parse5DomAdapter.prototype.getElementForSelectorCheck = function getElementForSelectorCheck(el) {
        return el;
    };

    Parse5DomAdapter.prototype.needToProcessUrl = function needToProcessUrl(tagName, target) {
        if (this.IFRAME_FLAG_TAGS.indexOf(tagName) !== -1 && target === '_parent') return false;

        return true;
    };

    Parse5DomAdapter.prototype.attachEventEmitter = function attachEventEmitter(domProcessor) {
        var eventEmitter = new _events2.default.EventEmitter();

        domProcessor.on = eventEmitter.on.bind(eventEmitter);
        domProcessor.off = eventEmitter.removeListener.bind(eventEmitter);
        domProcessor.emit = eventEmitter.emit.bind(eventEmitter);
    };

    Parse5DomAdapter.prototype.hasIframeParent = function hasIframeParent() {
        return this.isIframe;
    };

    Parse5DomAdapter.prototype.getCrossDomainPort = function getCrossDomainPort() {
        return this.crossDomainPort;
    };

    Parse5DomAdapter.prototype.getProxyUrl = function getProxyUrl() {
        return urlUtils.getProxyUrl.apply(urlUtils, arguments);
    };

    Parse5DomAdapter.prototype.isTopParentIframe = function isTopParentIframe() {
        return false;
    };

    Parse5DomAdapter.prototype.sameOriginCheck = function sameOriginCheck(location, checkedUrl) {
        return urlUtils.sameOriginCheck(location, checkedUrl);
    };

    return Parse5DomAdapter;
})(_baseDomAdapter2.default);

exports.default = Parse5DomAdapter;
module.exports = exports.default;