var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard').default;

exports.__esModule = true;
exports.process = process;

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _page = require('./page');

var _page2 = _interopRequireDefault(_page);

var _manifest = require('./manifest');

var _manifest2 = _interopRequireDefault(_manifest);

var _script = require('./script');

var _script2 = _interopRequireDefault(_script);

var _stylesheet = require('./stylesheet');

var _stylesheet2 = _interopRequireDefault(_stylesheet);

var _utilsUrl = require('../../utils/url');

var urlUtil = _interopRequireWildcard(_utilsUrl);

var _encoding = require('../encoding');

function getResourceUrlReplacer(ctx) {
    return function (resourceUrl, resourceType, charsetAttrValue, baseUrl) {
        // NOTE: Resolves base URLs without a protocol ('//google.com/path' for example).
        baseUrl = baseUrl ? _url2.default.resolve(ctx.dest.url, baseUrl) : '';
        resourceUrl = urlUtil.prepareUrl(resourceUrl);

        var resolvedUrl = _url2.default.resolve(baseUrl || ctx.dest.url, resourceUrl);
        var charsetStr = charsetAttrValue || resourceType === urlUtil.SCRIPT && ctx.contentInfo.charset.get();

        resolvedUrl = _utilsUrl.ensureTrailingSlash(resourceUrl, resolvedUrl);

        try {
            return ctx.toProxyUrl(resolvedUrl, false, resourceType, charsetStr);
        } catch (err) {
            return resourceUrl;
        }
    };
}

function process(ctx) {
    var processors, body, contentInfo, encoding, charset, decoded, i, urlReplacer, processed;
    return _regeneratorRuntime.async(function process$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                processors = [_page2.default, _manifest2.default, _script2.default, _stylesheet2.default];
                body = ctx.destResBody;
                contentInfo = ctx.contentInfo;
                encoding = contentInfo.encoding;
                charset = contentInfo.charset;
                context$1$0.next = 7;
                return _regeneratorRuntime.awrap(_encoding.decodeContent(body, encoding, charset));

            case 7:
                decoded = context$1$0.sent;
                i = 0;

            case 9:
                if (!(i < processors.length)) {
                    context$1$0.next = 23;
                    break;
                }

                if (!processors[i].shouldProcessResource(ctx)) {
                    context$1$0.next = 20;
                    break;
                }

                urlReplacer = getResourceUrlReplacer(ctx);
                processed = processors[i].processResource(decoded, ctx, charset, urlReplacer);

                if (!(processed === _page2.default.RESTART_PROCESSING)) {
                    context$1$0.next = 17;
                    break;
                }

                context$1$0.next = 16;
                return _regeneratorRuntime.awrap(process(ctx));

            case 16:
                return context$1$0.abrupt('return', context$1$0.sent);

            case 17:
                context$1$0.next = 19;
                return _regeneratorRuntime.awrap(_encoding.encodeContent(processed, encoding, charset));

            case 19:
                return context$1$0.abrupt('return', context$1$0.sent);

            case 20:
                i++;
                context$1$0.next = 9;
                break;

            case 23:
                return context$1$0.abrupt('return', body);

            case 24:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this);
}