exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _nodeBuilder = require('../node-builder');

var _toolsEsotope = require('../tools/esotope');

// Transform:
// eval(script); --> eval(__proc$Script(script));

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_toolsEsotope.Syntax.CallExpression],

    condition: function (node) {
        if (!node.arguments.length) return false;

        // eval()
        if (node.callee.type === _toolsEsotope.Syntax.Identifier && node.callee.name === 'eval') return true;

        // obj.eval(), obj['eval'](),
        return node.callee.type === _toolsEsotope.Syntax.MemberExpression && (node.callee.property.name || node.callee.property.value) === 'eval';
    },

    run: function (node) {
        node.arguments[0] = _nodeBuilder.createProcessScriptMethCall(node.arguments[0]);

        return null;
    }
};
module.exports = exports.default;