exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _toolsEsotope = require('../tools/esotope');

var _nodeBuilder = require('../node-builder');

// Transform:
// for(obj[prop] in src), for(obj.prop in src) -->
// for(var __set$temp in src) { obj[prop] = __set$temp; }

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_toolsEsotope.Syntax.ForInStatement],

    condition: function (node) {
        return node.left.type === _toolsEsotope.Syntax.MemberExpression;
    },

    run: function (node) {
        var tempVarAst = _nodeBuilder.createTempVarIdentifier();

        node.body.body.unshift(_nodeBuilder.createAssignmentExprStmt(node.left, tempVarAst));

        node.left = _nodeBuilder.createVarDeclaration(tempVarAst);

        return null;
    }
};
module.exports = exports.default;