var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _computedPropertyGet = require('./computed-property-get');

var _computedPropertyGet2 = _interopRequireDefault(_computedPropertyGet);

var _computedPropertySet = require('./computed-property-set');

var _computedPropertySet2 = _interopRequireDefault(_computedPropertySet);

var _concatOperator = require('./concat-operator');

var _concatOperator2 = _interopRequireDefault(_concatOperator);

var _documentWrite = require('./document-write');

var _documentWrite2 = _interopRequireDefault(_documentWrite);

var _eval = require('./eval');

var _eval2 = _interopRequireDefault(_eval);

var _evalCallApply = require('./eval-call-apply');

var _evalCallApply2 = _interopRequireDefault(_evalCallApply);

var _evalGet = require('./eval-get');

var _evalGet2 = _interopRequireDefault(_evalGet);

var _windowEvalGet = require('./window-eval-get');

var _windowEvalGet2 = _interopRequireDefault(_windowEvalGet);

var _forIn = require('./for-in');

var _forIn2 = _interopRequireDefault(_forIn);

var _functionCtor = require('./function-ctor');

var _functionCtor2 = _interopRequireDefault(_functionCtor);

var _locationGet = require('./location-get');

var _locationGet2 = _interopRequireDefault(_locationGet);

var _storageGet = require('./storage-get');

var _storageGet2 = _interopRequireDefault(_storageGet);

var _locationPropertyGet = require('./location-property-get');

var _locationPropertyGet2 = _interopRequireDefault(_locationPropertyGet);

var _locationSet = require('./location-set');

var _locationSet2 = _interopRequireDefault(_locationSet);

var _propertyGet = require('./property-get');

var _propertyGet2 = _interopRequireDefault(_propertyGet);

var _propertySet = require('./property-set');

var _propertySet2 = _interopRequireDefault(_propertySet);

var _methodCall = require('./method-call');

var _methodCall2 = _interopRequireDefault(_methodCall);

var TRANSFORMERS = [_computedPropertyGet2.default, _computedPropertySet2.default, _concatOperator2.default, _documentWrite2.default, _eval2.default, _evalCallApply2.default, _evalGet2.default, _windowEvalGet2.default, _forIn2.default, _functionCtor2.default, _locationGet2.default, _storageGet2.default, _locationPropertyGet2.default, _locationSet2.default, _propertyGet2.default, _propertySet2.default, _methodCall2.default];

exports.default = (function createTransformerMap() {
    var transformerMap = {};

    for (var i = 0; i < TRANSFORMERS.length; i++) {
        var transformer = TRANSFORMERS[i];

        for (var j = 0; j < transformer.nodeTypes.length; j++) {
            var nodeType = transformer.nodeTypes[j];

            if (!transformerMap[nodeType]) transformerMap[nodeType] = [];

            transformerMap[nodeType].push(transformer);
        }
    }

    return transformerMap;
})();

module.exports = exports.default;