exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _nodeBuilder = require('../node-builder');

var _toolsEsotope = require('../tools/esotope');

var _instrumented = require('../instrumented');

// Transform:
// obj.method(args...); obj[method](args...); -->
// _call$(obj, 'method', args...); _call$(obj, method, args...);

exports.default = {
    nodeReplacementRequireTransform: true,

    nodeTypes: [_toolsEsotope.Syntax.CallExpression],

    condition: function (node) {
        var callee = node.callee;

        if (callee.type === _toolsEsotope.Syntax.MemberExpression) {
            if (callee.computed) {
                return callee.property.type === _toolsEsotope.Syntax.Literal ? _instrumented.shouldInstrumentMethod(callee.property.value) : true;
            }

            return _instrumented.shouldInstrumentMethod(callee.property.name);
        }

        return false;
    },

    run: function (node) {
        var callee = node.callee;
        var method = callee.computed ? callee.property : _nodeBuilder.createStringLiteral(callee.property.name);

        return _nodeBuilder.createMethCallWrapper(callee.object, method, node.arguments);
    }
};
module.exports = exports.default;