exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _nodeBuilder = require('../node-builder');

var _toolsEsotope = require('../tools/esotope');

var _instrumented = require('../instrumented');

// Transform:
// obj.<wrappable-property> = value -->
// __set$(obj, '<wrappable-property>', value)

exports.default = {
    nodeReplacementRequireTransform: true,

    nodeTypes: [_toolsEsotope.Syntax.AssignmentExpression],

    condition: function (node) {
        return node.operator === '=' && node.left.type === _toolsEsotope.Syntax.MemberExpression && !node.left.computed && node.left.property.type === _toolsEsotope.Syntax.Identifier && _instrumented.shouldInstrumentProperty(node.left.property.name);
    },

    run: function (node) {
        return _nodeBuilder.createPropertySetWrapper(node.left.property.name, node.left.object, node.right);
    }
};
module.exports = exports.default;