var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _nodeBuilder = require('../node-builder');

var _instruction = require('../instruction');

var _instruction2 = _interopRequireDefault(_instruction);

var _toolsEsotope = require('../tools/esotope');

// Transform:
// sessionStorage, localStorage -->
// __get$Storage(sessionStorage), __get$Storage(localStorage)

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_toolsEsotope.Syntax.Identifier],

    condition: function (node, parent) {
        if (node.name !== 'sessionStorage' && node.name !== 'localStorage') return false;

        // Skip: window.localStorage
        if (parent.type === _toolsEsotope.Syntax.MemberExpression && parent.property === node) return false;

        // Skip: var localStorage = value;
        if (parent.type === _toolsEsotope.Syntax.VariableDeclarator && parent.id === node) return false;

        // Skip: localStorage = value
        if (parent.type === _toolsEsotope.Syntax.AssignmentExpression && parent.left === node) return false;

        // Skip: { localStorage: value }
        if (parent.type === _toolsEsotope.Syntax.Property && parent.key === node) return false;

        // Skip: localStorage++ || localStorage-- || ++localStorage || --localStorage
        if (parent.type === _toolsEsotope.Syntax.UpdateExpression && parent.operator === '++' || parent.operator === '--') return false;

        // Skip: function (localStorage) { ... } || function func(localStorage) { ... }
        if ((parent.type === _toolsEsotope.Syntax.FunctionExpression || parent.type === _toolsEsotope.Syntax.FunctionDeclaration) && parent.params.indexOf(node) !== -1) return false;

        // Skip already transformed: __get$Storage(localStorage)
        if (parent.type === _toolsEsotope.Syntax.CallExpression && parent.callee.name === _instruction2.default.getStorage) return false;

        return true;
    },

    run: function (node) {
        return _nodeBuilder.createGetStorageMethCall(node.name);
    }
};
module.exports = exports.default;